/////////////////////////////////////
//															   //
//	Implemenation of Strbase class //
//															   //
//				Base Class						   //
//																 //
//				Chungho Chau						 //
//															   //
/////////////////////////////////////

#include "strbase.h"
#include <string.h>
#include <iostream.h>

// Constructor
StringBase::StringBase (const char *s)
{
	m_length = strlen(s);
	m_string = new char [m_length + 1];
	strcpy (m_string, s);
}


// Destructor
StringBase::~StringBase ()
{
	delete [] m_string;  // in pair with "new"
}


// Function Display
void StringBase::Display(BOOL needCRLF) const
{
	cout << m_string;

	if (needCRLF)
		cout << '\n';
}


// Display string with prefix and suffix
void StringBase::Display (const char *prefix, const char *suffix, BOOL needCRLF) const
{
	cout << prefix << m_string << suffix;

	if (needCRLF) cout << '\n';
}


// Function Put character
BOOL StringBase::Put_At (const char Character, const int Index)
{
	if (Index < 1 || Index > m_length)
		return FALSE;

  m_string[Index-1] = Character;
	return TRUE;
}


// Get function
char StringBase::Get_At (const int Index) const
{
	if (Index < 1 || Index > m_length)
		return NULL;

	return m_string[Index-1];
}


// Is_Empty function
BOOL StringBase::Is_Empty(void) const
{
	if (!m_string)
		return TRUE;
	else
		return FALSE;
} 


// return the length of the string object
BOOL StringBase::Length() const
{
	return m_length;
}


// Copy Operator Overloading
StringBase::StringBase(const StringBase &other)
{
	// delete of "m_string" is not neceesary
	m_length = other.m_length;
	m_string =  new char [m_length + 1];																			
	strcpy (m_string, other.m_string);
}


// assigning a character string
StringBase &StringBase::operator= (const char *other)
{		
	if (m_string)
	  delete [] m_string;

	m_length = strlen(other);
	m_string = new char [m_length + 1];
	strcpy (m_string, other);

	return *this;
}


// Assignment Operator to another String object
StringBase &StringBase::operator= (const StringBase &other)
{	
	if (this == &other)			
	  return *this;					

	if (m_string) delete [] m_string;	

	m_length = other.m_length;		
	char *temp = new char [m_length + 1];   
	strcpy (temp, other.m_string);
	m_string = temp;											

	return *this;
}


// overloading an equality operator with another "object"
StringBase::operator== (const StringBase &other) const
{
	return (strcmp(m_string, other.m_string) == 0 ? TRUE : FALSE);
		
}


// overloading equality operator with another "string"
BOOL StringBase::operator== (const char *other) const
{
	return (strcmp(m_string, other) == 0 ? TRUE : FALSE);
}



