/////////////////////////////////////////
//															       //
//	Implemenation of StringFixed class //
//															       //
//				  Derived Class 			       //
//															       //
/////////////////////////////////////////

#include <iostream.h>
#include <string.h>
#include "strfixd.h"



// Constructor
StringFixed::StringFixed (const char *s)
 : StringBase (s) 
{
	if (strlen(s) > MAX_STRING)
		m_string[MAX_STRING]='\0';
}

// Destructor
StringFixed::~StringFixed ()
{
	// delete is done in base class StingBase ??
}


// Copy Operator Overloading
StringFixed::StringFixed(const StringFixed &other)
{
	// delete of "m_string" is not neceesary
	m_length = other.m_length;
	m_string =  new char [m_length + 1];																			
	strcpy (m_string, other.m_string);
}


// assigning a character string
StringFixed &StringFixed::operator= (const char *other)
{		
	if (m_string)
	  delete [] m_string;

	m_length = strlen(other);
	m_string = new char [m_length + 1];
	strcpy (m_string, other);

	return *this;
}


// Assignment Operator to another String object
StringFixed &StringFixed::operator= (const StringFixed &other)
{	
	if (this == &other)			
	  return *this;					

	if (m_string) delete [] m_string;	

	m_length = other.m_length;		
	char *temp = new char [m_length + 1];   
	strcpy (temp, other.m_string);
	m_string = temp;											

	return *this;
}


// overloading an equality operator with another "object"
StringFixed::operator== (const StringFixed &other) const
{
	return (strcmp(m_string, other.m_string) == 0 ? TRUE : FALSE);
		
}


// overloading equality operator with another "string"
BOOL StringFixed::operator== (const char *other) const
{
	return (strcmp(m_string, other) == 0 ? TRUE : FALSE);
}
