////////////////////////////////////
//																//
//  Definiton of the Patron Class //
//																//
//					Chungho Chau					//
//																//
////////////////////////////////////

#ifndef PATRON_CLASS
#define PATRON_CLASS

#include "VString.h"


class Patron {
	
	public:

				Patron(const char *first, const char *last, const int age); // no default				
				~Patron() {};

				// copy operator
				Patron(const Patron &other);
			
				// assignment operator	
				Patron &operator= (const Patron &other);	// optional
		//		VString &operator= (const char *other); // cannot be applied

				// equality operator
				BOOL operator== (const Patron &other) const;
		//		BOOL operator== (const char *other) const; // cannot be applied

				void Display_All_Info(void) const;
				void Display_Full_Name(void) const;
				void Display_First_Name(void) const;
				void Display_Last_Name(void) const;
				void Display_Age(void) const;

				void Change_First_Name(const char *first);
				void Change_Last_Name(const char *last);
				void Change_Age(const int age);

	private:
				VString m_first_name;
				VString m_last_name;
				int m_age;
};


#endif